# SPDX-FileCopyrightText: Copyright (c) 2025, Linaro Limited.
#
# SPDX-License-Identifier: MIT
---
device_type: fvp
job_name: {{ CI_JOB_NAME }}

timeouts:
  connection:
    minutes: 3
  job:
    minutes: 80
  actions:
    auto-login-action:
      minutes: 5
    fvp-deploy:
      minutes: 20
    download-retry:
      minutes: 20
    http-download:
      minutes: 20

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/corstone1000-fvp/mender.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility:
  group:
    - cassini

context:
  boot_character_delay: 250
  test_character_delay: 250

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

actions:
- deploy:
    to: fvp
    images:
      bl1:
        url: {{ BL1_ARTIFACT }}
      cs1000:
        url: {{ FIRMWARE_ARTIFACT }}
      extsys:
        url: {{ EXTSYS_ARTIFACT }}
      mmc0:
        url: {{ IMAGE_ARTIFACT }}
        compression: gz

- boot:
    method: fvp
    docker:
      name: "{{ CI_REGISTRY_IMAGE }}/cs1k-fvp-test-image:{{ DOCKER_IMAGE_TAG }}"
    image: /opt/models/Linux64_GCC-9.3/FVP_Corstone-1000
    version_string: 'Fast Models [^\\n]+'
    timeout:
      minutes: 15
    console_string: 'host_terminal_0: Listening for serial connection on port (?P<PORT>\d+)'
    feedbacks:
      - '(?P<NAME>host_terminal_1): Listening for serial connection on port (?P<PORT>\d+)'
      - '(?P<NAME>secenc_terminal): Listening for serial connection on port (?P<PORT>\d+)'
      - '(?P<NAME>extsys_terminal): Listening for serial connection on port (?P<PORT>\d+)'
    arguments:
      - "-C se.trustedBootROMloader.fname={BL1}"
      - "-C board.msd_mmc.p_mmc_file={MMC0}"
      - "-C extsys_harness0.extsys_flashloader.fname={EXTSYS}"
      - "-C extsys0.extsys_terminal.start_telnet=1"
      - "-C host.host_terminal_0.start_telnet=1"
      - "-C host.host_terminal_1.start_telnet=1"
      - "-C se.secenc_terminal.start_telnet=1"
      - "--data board.flash0={CS1000}@0x68000000"
    auto_login:
      login_prompt: 'corstone1000-fvp login:.*'
      username: cassini
      login_commands:
        - cassini123
        - cassini123
        - sudo su -
        - eth0=$(ip -o link show | grep "link/ether" | head -n 1 | awk '-F:' '{print $2}')
        - wait-online.sh $eth0
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@corstone1000-fvp:.+\$ '
      - '@corstone1000-fvp:.+# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf

- test:
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: cassini-mender-tests
            description: "Run Cassini mender tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - timedatectl
              - sudo systemctl restart systemd-timesyncd.service
              - timedatectl
              - lava-test-case cassini-mender-tests --shell "systemctl status mender-connect.service | grep "active""
        from: inline
        name: cassini-mender-tests
        path: inline/cassini-mender-tests.yaml
